## criu 2.0

=== Makefile ===
#
# Import the build engine first
__nmk_dir=$(CURDIR)/scripts/nmk/scripts/
export __nmk_dir

include $(__nmk_dir)/include.mk
include $(__nmk_dir)/macro.mk

#
# Import tools versions early
# so subsequents may refer them.
include Makefile.versions

#
# To build host helpers.
HOSTCC		?= gcc
HOSTLD		?= ld
export HOSTCC HOSTLD

CFLAGS		+= $(USERCFLAGS)
export CFLAGS

HOSTCFLAGS	?= $(CFLAGS)
export HOSTCFLAGS

#
# Where we live.
SRC_DIR	:= $(CURDIR)
export SRC_DIR

#
# General architecture specific options.
UNAME-M := $(shell uname -m)
export UNAME-M

ifeq ($(ARCH),arm)
        ARMV		:= $(shell echo $(UNAME-M) | sed -nr 's/armv([[:digit:]]).*/\1/p; t; i7')
        DEFINES		:= -DCONFIG_ARMV$(ARMV)

        USERCFLAGS += -Wa,-mimplicit-it=always

        ifeq ($(ARMV),6)
                USERCFLAGS += -march=armv6
        endif

        ifeq ($(ARMV),7)
                USERCFLAGS += -march=armv7-a
        endif

        PROTOUFIX	:= y
endif

ifeq ($(ARCH),x86)
        DEFINES		:= -DCONFIG_X86_64
endif

ifeq ($(ARCH),aarch64)
	VDSO         := y
endif

#
# The PowerPC 64 bits architecture could be big or little endian.
# They are handled in the same way.
#
ifeq ($(ARCH),ppc64)
        ifeq ($(UNAME-M),ppc64)
                error := $(error ppc64 big endian not yet supported)
        endif

        DEFINES		:= -DCONFIG_PPC64
endif

export PROTOUFIX DEFINES USERCFLAGS

#
# Independent options for all tools.
DEFINES			+= -D_FILE_OFFSET_BITS=64
DEFINES			+= -D_GNU_SOURCE

CFLAGS			+= $(USERCFLAGS)

WARNINGS		:= -Wall

CFLAGS-GCOV		:= --coverage -fno-exceptions -fno-inline
export CFLAGS-GCOV

ifeq ($(GCOV),1)
        LDFLAGS         += -lgcov
        DEBUG           := 1
        CFLAGS          += $(CFLAGS-GCOV)
endif

ifneq ($(WERROR),0)
        WARNINGS	+= -Werror
endif

ifeq ($(DEBUG),1)
        DEFINES		+= -DCR_DEBUG
        CFLAGS		+= -O0 -ggdb3
else
        CFLAGS		+= -O2 -g
endif

CFLAGS			+= $(WARNINGS) $(DEFINES)

#
# Protobuf images first, they are not depending
# on anything else.
$(eval $(call gen-built-in,images))
PHONY += images

#
# CRIU building done in own directory
# with slightly different rules so we
# can't use nmk engine directly (we
# build syscalls library and such).
#
# But note that we're already included
# the nmk so we can reuse it there.
criu/%: images/built-in.o
	$(Q) $(MAKE) -C criu $@
criu: images/built-in.o
	$(Q) $(MAKE) -C criu all
.PHONY: criu

#
# Libraries next once criu it ready
# (we might generate headers and such
# when building criu itself).
lib/%: criu
	$(Q) $(MAKE) -C lib $@
lib: criu
	$(Q) $(MAKE) -C lib all
PHONY += lib

all: criu lib
PHONY += all

clean-built:
	$(Q) $(MAKE) $(build)=images clean
	$(Q) $(MAKE) -C criu clean
	$(Q) $(MAKE) -C lib clean
	$(Q) $(MAKE) -C Documentation clean
PHONY += clean-built

clean: clean-built
	$(call msg-clean, criu)
	$(Q) $(RM) cscope.*
	$(Q) $(RM) tags TAGS
PHONY += clean

#
# Non-CRIU stuff.
#

docs:
	$(Q) $(MAKE) -s -C Documentation all
PHONY += docs

zdtm: all
	$(Q) MAKEFLAGS= $(MAKE) -C test/zdtm all
PHONY += zdtm

test: zdtm
	$(Q) MAKEFLAGS= $(MAKE) -C test
PHONY += test

tar-name := $(shell git tag -l v$(CRIU_VERSION))
ifeq ($(tar-name),)
        tar-name := $(shell git describe)
endif
criu-$(tar-name).tar.bz2:
	git archive --format tar --prefix 'criu-$(tar-name)/' $(tar-name) | bzip2 > $@
dist tar: criu-$(tar-name).tar.bz2
	@true
.PHONY: dist tar

tags:
	$(call msg-gen, $@)
	$(Q) $(RM) tags
	$(Q) $(FIND) . -name '*.[hcS]' ! -path './.*' ! -path './test/*' -print | xargs $(CTAGS) -a
PHONY += tags

etags:
	$(call msg-gen, $@)
	$(Q) $(RM) TAGS
	$(Q) $(FIND) . -name '*.[hcS]' ! -path './.*' ! -path './test/*' -print | xargs $(ETAGS) -a
PHONY += etags


cscope:
	$(call msg-gen, $@)
	$(Q) $(FIND) . -name '*.[hcS]' ! -path './.*' ! -path './test/*' ! -type l -print > cscope.files
	$(Q) $(CSCOPE) -bkqu
PHONY += cscope

gcov:
	$(E) " GCOV"
	$(Q) test -d gcov || mkdir gcov && \
	cp criu/*.{gcno,c,h} test/`pwd`/criu/   && \
	geninfo --output-filename gcov/crtools.h.info --no-recursion criu/ && \
	geninfo --output-filename gcov/crtools.ns.info --no-recursion test/`pwd`/criu/ && \
	sed -i "s#/test`pwd`##" gcov/crtools.ns.info && \
	cd gcov && \
	lcov --rc lcov_branch_coverage=1 --add-tracefile crtools.h.info \
	--add-tracefile crtools.ns.info --output-file criu.info && \
	genhtml --rc lcov_branch_coverage=1 --output-directory html criu.info
	@echo "Code coverage report is in `pwd`/gcov/html/ directory."
PHONY += gcov

docker-build:
	$(MAKE) -C scripts/build/ x86_64 

PHONY += docker-build

docker-test:
	docker run --rm -it --privileged criu-x86_64 ./test/zdtm.py run -a -x tcp6 -x tcpbuf6 -x static/rtc -x cgroup
PHONY += docker-test

help:
	@echo '    Targets:'
	@echo '      all             - Build all [*] targets'
	@echo '    * criu            - Build criu'
	@echo '      zdtm            - Build zdtm test-suite'
	@echo '      docs            - Build documentation'
	@echo '      install         - Install binary and man page'
	@echo '      dist            - Create a source tarball'
	@echo '      clean           - Clean everything'
	@echo '      tags            - Generate tags file (ctags)'
	@echo '      etags           - Generate TAGS file (etags)'
	@echo '      cscope          - Generate cscope database'
	@echo '      rebuild         - Force-rebuild of [*] targets'
	@echo '      test            - Run zdtm test-suite'
	@echo '      gcov            - Make code coverage report'
PHONY += help

include Makefile.install

.PHONY: $(PHONY)

.DEFAULT_GOAL := all

#
# Optional local include.
-include Makefile.local

=== Documentation/Makefile ===
include $(__nmk_dir)/include.mk
include $(__nmk_dir)/macro.mk

ASCIIDOC	:= asciidoc
A2X		:= a2x
XMLTO		:= xmlto

SRC		+= criu.txt
XMLS		:= $(patsubst %.txt,%.xml,$(SRC))
MANS		:= $(patsubst %.txt,%.8,$(SRC))
MAN8DIR		:= $(MANDIR)/man8

GROFF		:=groff
PAPER		:=$(shell paperconf 2>/dev/null || echo letter)
GROFF_OPTS	:= -Tps -t -dpaper=$(PAPER) -P-p$(PAPER) -man -msafer -rC1 -rD1 -rS11
PSS		:= $(MANS:%.8=%.ps)
PDFS		:= $(MANS:%.8=%.pdf)

all: check $(MANS)
ps: $(PSS)
pdf: $(PDFS)
.PHONY: all ps pdf check

check:
	$(Q) for B in $(ASCIIDOC) $(A2X) $(XMLTO); do	\
		$$B --version > /dev/null || exit 1;	\
	done

%.8: %.txt
	$(call msg-gen, $@)
	$(Q) $(ASCIIDOC) -b docbook -d manpage -o $(patsubst %.8,%.xml,$@) $<
	$(Q) $(XMLTO) man --skip-validation $(patsubst %.8,%.xml,$@) 2>/dev/null

%.ps: %.8
	$(call msg-gen, $@)
	$(Q) $(GROFF) $(GROFF_OPTS) $^ > $@

%.pdf: %.ps
	$(call msg-gen, $@)
	$(Q) ps2pdf $< $@

clean:
	$(call msg-clean, "Documentation")
	$(Q) rm -f $(XMLS) $(MANS) $(PSS) $(PDFS)

install: $(MANS)
	$(E) "  INSTALL " $(MANS)
	$(Q) mkdir -p $(DESTDIR)$(MAN8DIR)
	$(Q) install -m 644 $(MANS) $(DESTDIR)$(MAN8DIR)

.PHONY: clean install

=== criu/Makefile ===
#
# HOST part is needed to build helper
# tools such as piegen.
HOSTCC			?= gcc
HOSTLD			?= ld
HOSTCFLAGS		?= $(CFLAGS)
CFLAGS			+= $(USERCFLAGS)

export HOSTCC HOSTLD HOSTCFLAGS

ifeq ($(ARCH),x86)
        SRCARCH		:= x86
        LDARCH		:= i386:x86-64
        VDSO		:= y
endif

ifeq ($(ARCH),arm)
        SRCARCH		:= arm
endif

ifeq ($(ARCH),arm64)
        ARCH		:= aarch64
        SRCARCH		:= aarch64
        VDSO		:= y
endif

ifeq ($(ARCH),ppc64)
        SRCARCH		:= ppc64
        LDARCH		:= powerpc:common64
        VDSO		:= y
endif

LDARCH ?= $(SRCARCH)

export SRCARCH LDARCH VDSO

SRCARCH			?= $(ARCH)
LDARCH			?= $(SRCARCH)
ARCH_DIR		:= arch/$(SRCARCH)

export SRCARCH LDARCH ARCH_DIR VDSO

$(if $(wildcard $(ARCH_DIR)),,$(error "The architecture $(ARCH) isn't supported"))

#
# General flags.
ccflags-y		+= -fno-strict-aliasing
ccflags-y		+= -iquote $(SRC_DIR)/criu/include
ccflags-y		+= -iquote $(SRC_DIR)/images
ccflags-y		+= -iquote $(SRC_DIR)/criu/pie
ccflags-y		+= -iquote $(SRC_DIR)/criu/$(ARCH_DIR)
ccflags-y		+= -iquote $(SRC_DIR)/criu/$(ARCH_DIR)/include
ccflags-y		+= -iquote $(SRC_DIR)/
ccflags-y		+= -I/usr/include/libnl3

export ccflags-y

LIBS			:= -lrt -lpthread -lprotobuf-c -ldl -lnl-3
REQ-LIBS-NAMES          := libpthread libprotobuf-c libnl-3

#
# Make sure all required libs are installed
ifneq ($(MAKECMDGOALS),clean)
        ifneq ($(shell sh -c                                                            \
                        'TMP="$(OUTPUT)$(TMPOUT).$$$$";                                 \
                        echo "int main(int argc, char *argv[]) { return 0; }" |         \
                        "$(CC)" -x c - $(LIBS) -o "$$TMP" > /dev/null 2>&1 && echo y;   \
                        rm -f "$$TMP"'),y)
                $(error "Make sure '$(REQ-LIBS-NAMES)' libraries are installed")
        endif
endif
ifeq ($(GMON),1)
	CFLAGS		+= -pg
	GMONLDOPT	:= -pg
endif

#
# piegen tool might be disabled by hands. Don't use it until
# you know what you're doing.
ifneq ($(filter ia32 x86 ppc64,$(ARCH)),)
        ifneq ($(PIEGEN),no)
                piegen-y := y
                export piegen-y
        endif
endif

# msg-* printing
include $(__nmk_dir)/msg.mk

#
# Version header file.
include Makefile.version

#
# Configure variables.
include Makefile.config
config: $(VERSION_HEADER)

#
# System calls library.
SYSCALL-LIB		:= $(ARCH_DIR)/syscalls.built-in.o
syscalls_lib: config
	$(Q) $(MAKE) $(call build-as,Makefile.syscalls,$(ARCH_DIR)) all
.PHONY: syscalls_lib

#
# Architecture dependant part.
ARCH-LIB		:= $(ARCH_DIR)/crtools.built-in.o
arch_lib: syscalls_lib
	$(Q) $(MAKE) $(call build-as,Makefile,$(ARCH_DIR)) all
.PHONY: arch_lib

#
# piegen tool needed for PIE code.
ifeq ($(piegen-y),y)
piegen-bin		:= pie/piegen/piegen

pie/piegen/%: config
	$(Q) CC=$(HOSTCC) LD=$(HOSTLD) CFLAGS="$(ccflags-y) $(HOSTCFLAGS) $(WARNINGS) $(DEFINES)" $(MAKE) $(build)=pie/piegen $@
$(piegen-bin): pie/piegen/built-in.o
	$(call msg-link, $@)
	$(Q) $(HOSTCC) $(HOSTCFLAGS) $^ $(LDFLAGS) -o $@
endif

#
# PIE library code.
pie/lib.a: arch_lib
	$(Q) $(MAKE) $(call build-as,Makefile.library,pie) all

#
# PIE code blobs themseves.
pie: $(piegen-bin) pie/lib.a
	$(Q) $(MAKE) $(build)=pie all
.PHONY: pie

#
# CRIU executable
PROGRAM-BUILTINS	+= ../images/built-in.o
PROGRAM-BUILTINS	+= built-in.o
PROGRAM-BUILTINS	+= pie/lib.a

built-in.o: pie
	$(Q) $(MAKE) $(call build-as,Makefile.crtools,.) all

criu: $(PROGRAM-BUILTINS)
	$(call msg-link, $@)
	$(Q) $(CC) $(CFLAGS) $^ $(SYSCALL-LIB) $(ARCH-LIB) $(LIBS) $(LDFLAGS) $(GMONLDOPT) -rdynamic -o $@

#
# Cleanup everything.
clean:
	$(Q) $(MAKE) $(call build-as,Makefile.syscalls,$(ARCH_DIR)) $@
	$(Q) $(MAKE) $(call build-as,Makefile.library,pie) $@
	$(Q) $(MAKE) $(call build-as,Makefile.crtools,.) $@
	$(Q) $(MAKE) $(build)=pie/piegen $@
	$(Q) $(MAKE) $(build)=pie $@
	$(Q) $(RM) ./*.{gcda,gcno,gcov}
	$(Q) $(RM) ./pie/*.{gcda,gcno,gcov}
	$(Q) $(RM) ./pie/piegen/*.{gcda,gcno,gcov}
	$(Q) $(RM) -r ./gcov
	$(Q) $(RM) $(VERSION_HEADER)
	$(Q) $(RM) $(CONFIG_HEADER)
	$(Q) $(RM) criu
.PHONY: clean

UAPI_HEADERS := include/criu-plugin.h include/criu-log.h

install: criu
	$(E) "  INSTALL " criu
	$(Q) mkdir -p $(DESTDIR)$(SBINDIR)
	$(Q) install -m 755 criu $(DESTDIR)$(SBINDIR)
	$(Q) mkdir -p $(DESTDIR)$(INCLUDEDIR)
	$(Q) install -m 644 $(UAPI_HEADERS) $(DESTDIR)$(INCLUDEDIR)
.PHONY: install

#
# Final @all target.
all: criu
	@true
.PHONY: all

=== images/Makefile ===
proto-obj-y	+= stats.o
proto-obj-y	+= core.o
proto-obj-y	+= core-x86.o
proto-obj-y	+= core-arm.o
proto-obj-y	+= core-aarch64.o
proto-obj-y	+= core-ppc64.o
proto-obj-y	+= cpuinfo.o
proto-obj-y	+= inventory.o
proto-obj-y	+= fdinfo.o
proto-obj-y	+= fown.o
proto-obj-y	+= ns.o
proto-obj-y	+= regfile.o
proto-obj-y	+= ghost-file.o
proto-obj-y	+= fifo.o
proto-obj-y	+= remap-file-path.o
proto-obj-y	+= eventfd.o
proto-obj-y	+= eventpoll.o
proto-obj-y	+= fh.o
proto-obj-y	+= fsnotify.o
proto-obj-y	+= signalfd.o
proto-obj-y	+= fs.o
proto-obj-y	+= pstree.o
proto-obj-y	+= pipe.o
proto-obj-y	+= tcp-stream.o
proto-obj-y	+= sk-packet.o
proto-obj-y	+= mnt.o
proto-obj-y	+= pipe-data.o
proto-obj-y	+= sa.o
proto-obj-y	+= timer.o
proto-obj-y	+= timerfd.o
proto-obj-y	+= mm.o
proto-obj-y	+= sk-opts.o
proto-obj-y	+= sk-unix.o
proto-obj-y	+= sk-inet.o
proto-obj-y	+= tun.o
proto-obj-y	+= sk-netlink.o
proto-obj-y	+= packet-sock.o
proto-obj-y	+= ipc-var.o
proto-obj-y	+= ipc-desc.o
proto-obj-y	+= ipc-shm.o
proto-obj-y	+= ipc-msg.o
proto-obj-y	+= ipc-sem.o
proto-obj-y	+= utsns.o
proto-obj-y	+= creds.o
proto-obj-y	+= vma.o
proto-obj-y	+= netdev.o
proto-obj-y	+= tty.o
proto-obj-y	+= file-lock.o
proto-obj-y	+= rlimit.o
proto-obj-y	+= pagemap.o
proto-obj-y	+= siginfo.o
proto-obj-y	+= rpc.o
proto-obj-y	+= ext-file.o
proto-obj-y	+= cgroup.o
proto-obj-y	+= userns.o
proto-obj-y	+= google/protobuf/descriptor.o # To make protoc-c happy and compile opts.proto
proto-obj-y	+= opts.o
proto-obj-y	+= seccomp.o
proto-obj-y	+= binfmt-misc.o
proto-obj-y	+= time.o

CFLAGS		+= -iquote $(obj)/

#
# Generates a set of names from protobuf "import" directive.
# The names are bare, ie no suffixes.
define gen-proto-dep-names
$(shell grep "^[[:blank:]]*import[[:blank:]]" $(1)      |       \
        sed     -e 's/[[:blank:]]*import[[:blank:]]*//'         \
                -e 's/[\";]//g'                                 \
                -e 's/\.proto//g'                       |       \
        sort | uniq)
endef

#
# Generates rules needed to compile protobuf files.
define gen-proto-rules
$(obj)/$(1).pb-c.c $(obj)/$(1).pb-c.h: $(obj)/$(1).proto $(addsuffix .pb-c.c,$(addprefix $(obj)/,$(2)))
	$$(E) "  PBCC    " $$@
	$$(Q) protoc-c --proto_path=$(obj)/ --c_out=$(obj)/ $$<
ifeq ($(PROTOUFIX),y)
	$$(Q) sed -i -e 's/4294967295/0xFFFFFFFF/g' $$@
	$$(Q) sed -i -e 's/4294967295/0xFFFFFFFF/g' $$(patsubst %.c,%.h,$$@)
	$$(Q) sed -i -e 's/4294967295/0xFFFFFFFF/g' $$(patsubst %.h,%.c,$$@)
endif
$(obj)/$(1).pb-c.d: $(obj)/$(1).pb-c.c $(addsuffix .pb-c.d,$(addprefix $(obj)/,$(2)))
	$$(E) "  DEP     " $$@
	$$(Q) $$(CC) -M -MT $$@ -MT $(patsubst %.d,%.o,$$@) $$(CFLAGS) $$< -o $$@
endef

$(foreach file, $(proto-obj-y),                                                 \
        $(eval $(call gen-proto-rules,$(file:.o=),                              \
                        $(call gen-proto-dep-names,                             \
                                $(addprefix $(obj)/,$(file:.o=.proto))))))

$(obj)/%.o: $(obj)/%.pb-c.c $(obj)/%.pb-c.h
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(obj)/built-in.o: $(addprefix $(obj)/,$(proto-obj-y))
	$(E) "  LINK    " $@
	$(Q) $(LD) $(ldflags-y) -r -o $@ $^

ifneq ($(MAKECMDGOALS),clean)
-include $(addprefix $(obj)/,$(proto-obj-y:.o=.pb-c.d))
endif

cleanup-y += $(obj)/*.c.d $(obj)/*.pb-c.c $(obj)/*.pb-c.h
cleanup-y += $(obj)/google/protobuf/*.d
cleanup-y += $(obj)/google/protobuf/*.h
cleanup-y += $(obj)/google/protobuf/*.c
cleanup-y += $(obj)/google/protobuf/*.o

=== lib/Makefile ===
include $(__nmk_dir)/include.mk
include $(__nmk_dir)/macro.mk

CRIU_SO			:= libcriu.so
UAPI_HEADERS		:= c/criu.h ../images/rpc.proto

#
# C language bindings.
c/%: ../Makefile.versions
	$(call msg-gen, $@)
	$(Q) $(MAKE) $(build)=c $@

cflags-so		+= $(CFLAGS) -rdynamic -Wl,-soname,$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR)
ldflags-so		+= -lprotobuf-c
c/$(CRIU_SO): c/built-in.o
	$(call msg-link, $@)
	$(Q) $(CC) -shared $(cflags-so) -o $@ $^ $(ldflags-so) $(LDFLAGS)
lib-c: c/$(CRIU_SO)
PHONY += lib-c

#
# Python bindings.
lib-py:
	$(call msg-gen, $@)
	$(Q) $(MAKE) -C py all
PHONY += lib-py

clean:
	$(call msg-clean, lib-c)
	$(Q) $(MAKE) $(build)=c $@
	$(Q) $(RM) c/$(CRIU_SO)
	$(Q) $(RM) c/criu.pc
	$(call msg-clean, lib-py)
	$(Q) $(MAKE) -C py $@

all: $(PHONY)
	@true
PHONY += all

install: lib-c lib-py ../crit/crit c/criu.pc.in
	$(E) "  INSTALL " $(CRIU_SO)
	$(Q) mkdir -p $(DESTDIR)$(LIBDIR)
	$(Q) install -m 755 c/$(CRIU_SO) $(DESTDIR)$(LIBDIR)/$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR)
	$(Q) ln -fns $(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR) $(DESTDIR)$(LIBDIR)/$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR)
	$(Q) ln -fns $(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR) $(DESTDIR)$(LIBDIR)/$(CRIU_SO)
	$(Q) mkdir -p $(DESTDIR)$(INCLUDEDIR)
	$(Q) install -m 644 $(UAPI_HEADERS) $(DESTDIR)$(INCLUDEDIR)
	$(E) "  INSTALL " pkgconfig/criu.pc
	$(Q) mkdir -p $(DESTDIR)$(LIBDIR)/pkgconfig
	$(Q) sed -e 's,@version@,$(CRIU_VERSION),' -e 's,@libdir@,$(LIBDIR),' -e 's,@includedir@,$(dir $(INCLUDEDIR)),' c/criu.pc.in > c/criu.pc
	$(Q) install -m 644 c/criu.pc $(DESTDIR)$(LIBDIR)/pkgconfig
	$(E) "  INSTALL " crit
	$(Q) python ../scripts/crit-setup.py install --root=$(DESTDIR) --prefix=$(PREFIX)
.PHONY: install

.PHONY: $(PHONY) clean

=== test/Makefile ===
RM := rm -f --one-file-system

ZDTM_ARGS ?= -C
export ZDTM_ARGS

all:
	$(MAKE) zdtm
	$(MAKE) zdtm-pre-dump
	$(MAKE) zdtm-snapshot
	$(MAKE) zdtm-iter
	$(MAKE) zdtm-freezer
.PHONY: all

TESTS = unix-callback mem-snap rpc libcriu mounts/ext security pipes crit socketpairs overlayfs

other:
	for t in $(TESTS); do				\
		setsid $(MAKE) -C others/$$t run || exit 1;	\
	done
.PHONY: other

zdtm_ct: zdtm_ct.c

zdtm:
	./zdtm.py run -a --parallel 2
.PHONY: zdtm

zdtm-pre-dump:
	./zdtm.py run --pre 2:1 -t zdtm/transition/fork -f uns
.PHONY: zdtm

zdtm-snapshot:
	./zdtm.py run --pre 2:1 --snap -t zdtm/transition/fork -f uns
.PHONY: zdtm-snapshot

zdtm-iter:
	./zdtm.py run --iters 3:1 -t zdtm/transition/fork -f uns
.PHONY: zdtm-iter

zdtm-freezer:
	./zdtm.py run --test zdtm/transition/thread-bomb --pre 3 --freezecg zdtm:t
	./zdtm.py run --test zdtm/transition/thread-bomb --pre 3 --freezecg zdtm:f
.PHONY: zdtm-freezer

fault-injection:
	$(MAKE) -C fault-injection
.PHONY: fault-injection

override CFLAGS += -D_GNU_SOURCE

clean_root:
	$(Q) ./zdtm.py clean nsroot
.PHONY: clean_root

clean: clean_root
	$(RM) zdtm_ct zdtm-tst-list
	$(Q) $(RM) *.log
	$(Q) $(RM) -r ./dump/
	$(Q) $(MAKE) -C zdtm cleandep clean cleanout
	$(Q) $(MAKE) -C libcriu clean
	$(Q) $(MAKE) -C rpc clean
	$(Q) $(MAKE) -C crit clean
.PHONY: clean

=== criu/pie/Makefile ===
target			+= parasite
target			+= restorer

parasite-obj-y		+= parasite.o
parasite-obj-y		+= ./$(ARCH_DIR)/parasite-head.o
parasite-obj-e		+= ./$(ARCH_DIR)/syscalls.built-in.o

restorer-obj-y		+= restorer.o
restorer-obj-y		+= ./$(ARCH_DIR)/restorer.o
restorer-obj-e		+= ./$(ARCH_DIR)/syscalls.built-in.o

#
# We can't provide proper mount implementation
# in parasite code -- it requires run-time rellocation
# applications, which is not the target of the
# project.
#
CFLAGS			:= $(filter-out -pg $(CFLAGS-GCOV),$(CFLAGS)) -iquote pie/piegen -iquote arch/$(ARCH)/include -iquote $(SRC_DIR) -iquote $(SRC_DIR)/criu/include

ifneq ($(filter-out ia32,$(ARCH)),)
        ccflags-y	+= -DCR_NOGLIBC -fpie -Wa,--noexecstack -fno-stack-protector
else
        ccflags-y	+= -DCR_NOGLIBC -fno-pic -Wa,--noexecstack -fno-stack-protector
endif

ifeq ($(SRCARCH),arm)
        ccflags-y	+= -marm
endif

asflags-y		+= -D__ASSEMBLY__

GEN-OFFSETS		:= $(obj)/../../scripts/gen-offsets.sh
BLOBS			:= $(obj)/parasite-blob.h $(obj)/restorer-blob.h

PIELDS			:= pie.lds.S

.SECONDARY:

ifeq ($(piegen-y),y)
target-name = $(patsubst pie/%-blob.h,%,$(1))

ifeq ($(SRCARCH),ppc64)
$(obj)/$(PIELDS): $(obj)/pie-reloc.lds.S.in
	$(call msg-gen, $@)
	$(Q) echo "OUTPUT_ARCH($(LDARCH))"              >  $(obj)/$(PIELDS)
	$(Q) cat $<					>> $(obj)/$(PIELDS)
else
ifeq ($(ARCH),x86)
$(obj)/$(PIELDS): $(obj)/pie-reloc.lds.S.in
	$(call msg-gen, $@)
	$(Q) echo "OUTPUT_ARCH(i386:x86-64)"		>  $(obj)/$(PIELDS)
	$(Q) echo "TARGET(elf64-x86-64)"		>> $(obj)/$(PIELDS)
	$(Q) cat $<					>> $(obj)/$(PIELDS)
else # i386 ia32
$(obj)/$(PIELDS): $(obj)/pie-reloc.lds.S.in
	$(call msg-gen, $@)
	$(Q) echo "OUTPUT_ARCH(i386)"			>  $(obj)/$(PIELDS)
	$(Q) echo "TARGET(elf32-i386)"			>> $(obj)/$(PIELDS)
	$(Q) cat $<					>> $(obj)/$(PIELDS)
endif
endif

ifeq ($(strip $(V)),)
        piegen_stdout := >/dev/null
endif

$(obj)/%.built-in.bin.o: $(obj)/%.built-in.o $(obj)/lib.a $(obj)/$(PIELDS)
	$(call msg-gen, $@)
	$(Q) $(LD) -r -T $(obj)/$(PIELDS) -o $@ $< $(obj)/lib.a

$(obj)/%-blob.h: $(obj)/%.built-in.bin.o $(obj)/$(PIELDS) pie/piegen
	$(call msg-gen, $@)
	$(Q) pie/piegen/piegen -f $< -v $(call target-name,$@)_relocs -p $(call target-name,$@)_blob_offset__ -s $(call target-name,$@)_blob -o $@ $(piegen_stdout)

else

$(obj)/$(PIELDS): $(obj)/$(PIELDS).in
	$(call msg-gen, $@)
	$(Q) $(SH) -c "echo 'OUTPUT_ARCH($(LDARCH))'	 > $(obj)/$(PIELDS)"
	$(Q) $(SH) -c "cat $(obj)/$(PIELDS).in		>> $(obj)/$(PIELDS)"

$(obj)/%.built-in.bin.o: $(obj)/%.built-in.o $(obj)/$(PIELDS)
	$(call msg-gen, $@)
	$(Q) $(LD) -r -T $(obj)/$(PIELDS) -o $@ $<

$(obj)/%.built-in.bin: $(obj)/%.built-in.bin.o
	$(call msg-gen, $@)
	$(Q) $(OBJCOPY) -O binary $^ $@

$(obj)/%-blob.h: $(obj)/%.built-in.bin $(GEN-OFFSETS)
	$(call msg-gen, $@)
	$(Q) $(SH) $(GEN-OFFSETS) $(@:-blob.h=) $(notdir $(@:-blob.h=)) $(CROSS_COMPILE) > $@

endif

$(BLOBS): $(obj)/$(PIELDS)
all-y += $(BLOBS)

cleanup-y += $(obj)/$(PIELDS)
cleanup-y += $(obj)/*.bin
cleanup-y += $(BLOBS)
cleanup-y += $(obj)/*.built-in.bin.o
cleanup-y += $(obj)/*.built-in.bin

=== lib/c/Makefile ===
obj-y			+= criu.o
obj-y			+= $(SRC_DIR)/images/rpc.pb-c.o

ccflags-y		+= -iquote $(SRC_DIR)/criu/$(ARCH_DIR)/include
ccflags-y		+= -iquote $(SRC_DIR)/criu/include -iquote $(obj)/..
ccflags-y		+= -iquote $(SRC_DIR)/images
ccflags-y		+= -fPIC -Wa,--noexecstack -fno-stack-protector

=== lib/py/Makefile ===
all: images rpc.py

.PHONY: all images clean

images:
	$(Q) $(MAKE) -C images all

# rpc_pb2.py doesn't depend on any other file, so
# it is safe to rename it, dropping ugly _pb2 suffix.
rpc.py:
	$(Q) protoc -I=$(SRC_DIR)/images/ --python_out=./ $(SRC_DIR)/images/$(@:.py=.proto)
	$(Q) mv $(@:.py=_pb2.py) $@

clean:
	$(Q) $(MAKE) -C images clean
	$(Q) $(RM) rpc.py *.pyc

=== scripts/nmk/Makefile ===
__nmk_dir=scripts/
export __nmk_dir

include $(__nmk_dir)include.mk

MAKEFLAGS := -r -R --no-print-directory

.PHONY: all help test docs clean install

help:
	@echo '    Targets:'
	@echo '      install dir=<dir>  - Install scripts into directory <dir>'
	@echo '      docs               - Build documentation'
	@echo '      clean              - Clean everything'

test:
	$(Q) $(MAKE) -C tests all

docs:
	$(Q) $(MAKE) -C Documentation all

install:
	@echo 'Copying scripts into $(dir)'
	@cp scripts/build.mk $(dir)
	@cp scripts/include.mk $(dir)
	@cp scripts/macro.mk $(dir)
	@cp scripts/main.mk $(dir)
	@cp scripts/rules.mk $(dir)
	@cp scripts/tools.mk $(dir)
	@cp scripts/utils.mk $(dir)

all:
	@true

clean:
	$(call msg-clean, "nmk")
	$(Q) $(MAKE) -C Documentation clean
	$(Q) $(MAKE) -C tests clean

.DEFAULT_GOAL ?= all

=== test/zdtm/Makefile ===
SUBDIRS	=	lib static transition

default:	all
.PHONY: default lib static transition

lib:
	$(MAKE) -C lib all

static: lib
	$(MAKE) -C static all

transition: lib
	$(MAKE) -C transition all

all: lib static transition
	@true
%:
	set -e; for d in $(SUBDIRS); do $(MAKE) -C $$d $@; done

=== criu/arch/aarch64/Makefile ===
builtin-name		:= crtools.built-in.o

ccflags-y		+= -iquote $(obj) -iquote $(SRC_DIR)
ccflags-y		+= -iquote $(obj)/include -iquote $(SRC_DIR)/criu/include

obj-y			+= cpu.o
obj-y			+= crtools.o

=== debian/changelog ===
criu (2.0-2ubuntu3) xenial; urgency=medium

  * Apply a couple of fixes to work with the Ubuntu kernel:
    - restore: don't pass cgroup nsroot= option to mount()
    - restore: correctly restore cgroup mounts inside a container

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 30 Mar 2016 11:51:33 -0400

criu (2.0-2ubuntu2) xenial; urgency=medium

  * Cherry-pick upstream fixes:
    - restore: zombies should collect their children
    - mount: ignore subvol argument in btrfs sb
    - namespaces: zero struct ns_id when allocating

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 23 Mar 2016 13:06:09 -0400

criu (2.0-2ubuntu1) xenial; urgency=medium

  * Make it build with Ubuntu hardening (LP: #1555861)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 10 Mar 2016 18:54:46 -0500

criu (2.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 08 Mar 2016 21:14:24 +0100

criu (2.0-1) experimental; urgency=medium

  * Imported Upstream version 2.0
  * Add Build-Depends on libnl-3-dev
  * Add Build-Depends on libcap-dev
  * Use HTTPS transport protocol for Vcs-Git URI
  * Update copyright years for debian/* packaging files
  * Declare compliance with Debian policy 3.9.7
  * debian/copyright: Update file paths after upstream file reorganisation
  * Sync manpage for crit to include short explanation for new subcommands

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 07 Mar 2016 20:19:11 +0100

=== debian/control ===
Source: criu
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends:
 asciidoc,
 debhelper (>= 9.20151219),
 dh-python,
 libcap-dev,
 libnl-3-dev,
 libprotobuf-c-dev,
 libprotobuf-dev,
 protobuf-c-compiler,
 protobuf-compiler,
 python-all (>= 2.6.6-3~),
 xmlto
Standards-Version: 3.9.7
Homepage: http://www.criu.org/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/criu.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/criu.git

Package: criu
Architecture: amd64 armhf ppc64el
Depends: python-ipaddr, python-protobuf, ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Recommends: iproute2 | iproute
Description: checkpoint and restore in userspace
 criu contains the utilities to checkpoint and restore processes in
 userspace.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=-all

PACKAGE = $(firstword $(shell dh_listpackages))
TMP     = $(CURDIR)/debian/$(PACKAGE)

%:
	dh ${@} --parallel --with python2

override_dh_auto_install:
	dh_auto_install -- DESTDIR="$(CURDIR)/debian/criu" PREFIX="/usr"
	# remove empty directories as spotted by lintian
	# /usr/lib/systemd/system should not be installed
	find $(TMP)/usr/lib -type d -empty -delete

override_dh_auto_build:
	# CRIU doesn't talk to the linker through gcc
	LDFLAGS=-Bsymbolic-functions dh_auto_build

override_dh_auto_test:
	# disabled: doesn't work yet

override_dh_strip:
	dh_strip --ddeb-migration='criu-dbg (<< 1.8-2~)'

## criu 2.2

=== Documentation/Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 A2X		:= a2x
 XMLTO		:= xmlto
 
+FOOTER		:= footer.txt
 SRC		+= criu.txt
 XMLS		:= $(patsubst %.txt,%.xml,$(SRC))
 MANS		:= $(patsubst %.txt,%.8,$(SRC))
@@ -26,6 +27,16 @@
 		$$B --version > /dev/null || exit 1;	\
 	done
 
+$(FOOTER): ../Makefile.versions
+	$(call msg-gen, $@)
+	$(Q) echo ":doctype:       manpage"		>  $@
+	$(Q) echo ":man source:    criu"		>> $@
+	$(Q) echo ":man version:   $(CRIU_VERSION)"	>> $@
+	$(Q) echo ":man manual:    CRIU Manual"		>> $@
+
+$(SRC): $(FOOTER)
+	@true
+
 %.8: %.txt
 	$(call msg-gen, $@)
 	$(Q) $(ASCIIDOC) -b docbook -d manpage -o $(patsubst %.8,%.xml,$@) $<
@@ -41,11 +52,15 @@
 
 clean:
 	$(call msg-clean, "Documentation")
-	$(Q) rm -f $(XMLS) $(MANS) $(PSS) $(PDFS)
+	$(Q) rm -f $(XMLS) $(MANS) $(PSS) $(PDFS) $(FOOTER)
 
 install: $(MANS)
 	$(E) "  INSTALL " $(MANS)
 	$(Q) mkdir -p $(DESTDIR)$(MAN8DIR)
 	$(Q) install -m 644 $(MANS) $(DESTDIR)$(MAN8DIR)
 
-.PHONY: clean install
+uninstall:
+	$(E) " UNINSTALL" $(MANS)
+	$(Q) $(RM) $(addprefix $(DESTDIR)$(MAN8DIR)/,$(MANS))
+
+.PHONY: clean install uninstall

=== criu/Makefile ===
--- 
+++ 
@@ -5,6 +5,10 @@
 HOSTLD			?= ld
 HOSTCFLAGS		?= $(CFLAGS)
 CFLAGS			+= $(USERCFLAGS)
+
+# here is a workaround for a bug in libnl-3:
+# 6a8d90f5fec4 "attr: Allow attribute type 0" 
+WRAPFLAGS		+= -Wl,--wrap=nla_parse,--wrap=nlmsg_parse
 
 export HOSTCC HOSTLD HOSTCFLAGS
 
@@ -56,18 +60,47 @@
 export ccflags-y
 
 LIBS			:= -lrt -lpthread -lprotobuf-c -ldl -lnl-3
-REQ-LIBS-NAMES          := libpthread libprotobuf-c libnl-3
+
+REQ-RPM-PKG-NAMES	+= protobuf
+REQ-RPM-PKG-NAMES	+= protobuf-c
+REQ-RPM-PKG-NAMES	+= protobuf-c-devel
+REQ-RPM-PKG-NAMES	+= protobuf-compiler
+REQ-RPM-PKG-NAMES	+= protobuf-devel
+REQ-RPM-PKG-NAMES	+= protobuf-python
+REQ-RPM-PKG-NAMES	+= libnl3-devel
+
+REQ-DEB-PKG-NAMES	+= libprotobuf-dev
+REQ-DEB-PKG-NAMES	+= libprotobuf-c0-dev
+REQ-DEB-PKG-NAMES	+= protobuf-c-compiler
+REQ-DEB-PKG-NAMES	+= protobuf-compiler
+REQ-DEB-PKG-NAMES	+= python-protobuf
+REQ-DEB-PKG-NAMES	+= libnl-3-dev
+
+REQ-RPM-PKG-TEST-NAMES  += libaio-devel
+REQ-RPM-PKG-TEST-NAMES  += libcap-devel
+
+REQ-DEB-PKG-TEST-NAMES  += libaio-dev
+REQ-DEV-PKG-TEST-NAMES  += libcap-dev
 
 #
 # Make sure all required libs are installed
 ifneq ($(MAKECMDGOALS),clean)
+ifneq ($(MAKECMDGOALS),mrproper)
         ifneq ($(shell sh -c                                                            \
                         'TMP="$(OUTPUT)$(TMPOUT).$$$$";                                 \
                         echo "int main(int argc, char *argv[]) { return 0; }" |         \
                         "$(CC)" -x c - $(LIBS) -o "$$TMP" > /dev/null 2>&1 && echo y;   \
                         rm -f "$$TMP"'),y)
-                $(error "Make sure '$(REQ-LIBS-NAMES)' libraries are installed")
+                $(warning "Couldn't find some of the required libraries")
+                $(warning "Make sure the following packages are installed")
+                $(warning "RPM based distros: $(REQ-RPM-PKG-NAMES)")
+                $(warning "DEB based distros: $(REQ-DEB-PKG-NAMES)")
+                $(warning "To run tests the following packages are needed")
+                $(warning "RPM based distros: $(REQ-RPM-PKG-TEST-NAMES)")
+                $(warning "DEB based distros: $(REQ-DEB-PKG-TEST-NAMES)")
+                $(error "Compilation aborted")
         endif
+endif
 endif
 ifeq ($(GMON),1)
 	CFLAGS		+= -pg
@@ -144,24 +177,40 @@
 
 criu: $(PROGRAM-BUILTINS)
 	$(call msg-link, $@)
-	$(Q) $(CC) $(CFLAGS) $^ $(SYSCALL-LIB) $(ARCH-LIB) $(LIBS) $(LDFLAGS) $(GMONLDOPT) -rdynamic -o $@
-
-#
-# Cleanup everything.
-clean:
+	$(Q) $(CC) $(CFLAGS) $^ $(ARCH-LIB) $(LIBS) $(WRAPFLAGS) $(LDFLAGS) $(GMONLDOPT) -rdynamic -o $@
+
+
+subclean:
+	$(Q) $(RM) ./*.{gcda,gcno,gcov}
+	$(Q) $(RM) ./pie/*.{gcda,gcno,gcov}
+	$(Q) $(RM) ./pie/piegen/*.{gcda,gcno,gcov}
+	$(Q) $(RM) -r ./gcov
+	$(Q) $(RM) criu
+.PHONY: subclean
+
+#
+# Clean the most, except generated c files
+clean: subclean
 	$(Q) $(MAKE) $(call build-as,Makefile.syscalls,$(ARCH_DIR)) $@
+	$(Q) $(MAKE) $(call build-as,Makefile,$(ARCH_DIR)) $@
 	$(Q) $(MAKE) $(call build-as,Makefile.library,pie) $@
 	$(Q) $(MAKE) $(call build-as,Makefile.crtools,.) $@
 	$(Q) $(MAKE) $(build)=pie/piegen $@
 	$(Q) $(MAKE) $(build)=pie $@
-	$(Q) $(RM) ./*.{gcda,gcno,gcov}
-	$(Q) $(RM) ./pie/*.{gcda,gcno,gcov}
-	$(Q) $(RM) ./pie/piegen/*.{gcda,gcno,gcov}
-	$(Q) $(RM) -r ./gcov
+.PHONY: clean
+
+#
+# Delete all generated files
+mrproper: subclean
+	$(Q) $(MAKE) $(call build-as,Makefile.syscalls,$(ARCH_DIR)) $@
+	$(Q) $(MAKE) $(call build-as,Makefile,$(ARCH_DIR)) $@
+	$(Q) $(MAKE) $(call build-as,Makefile.library,pie) $@
+	$(Q) $(MAKE) $(call build-as,Makefile.crtools,.) $@
+	$(Q) $(MAKE) $(build)=pie/piegen $@
+	$(Q) $(MAKE) $(build)=pie $@
 	$(Q) $(RM) $(VERSION_HEADER)
 	$(Q) $(RM) $(CONFIG_HEADER)
-	$(Q) $(RM) criu
-.PHONY: clean
+.PHONY: mrproper
 
 UAPI_HEADERS := include/criu-plugin.h include/criu-log.h
 
@@ -173,6 +222,12 @@
 	$(Q) install -m 644 $(UAPI_HEADERS) $(DESTDIR)$(INCLUDEDIR)
 .PHONY: install
 
+uninstall:
+	$(E) " UNINSTALL" criu
+	$(Q) $(RM) $(addprefix $(DESTDIR)$(SBINDIR)/,criu)
+	$(Q) $(RM) $(addprefix $(DESTDIR)$(INCLUDEDIR)/,$(notdir $(UAPI_HEADERS)))
+.PHONY: uninstall
+
 #
 # Final @all target.
 all: criu

=== images/Makefile ===
--- 
+++ 
@@ -102,10 +102,13 @@
 	$(Q) $(LD) $(ldflags-y) -r -o $@ $^
 
 ifneq ($(MAKECMDGOALS),clean)
+ifneq ($(MAKECMDGOALS),mrproper)
 -include $(addprefix $(obj)/,$(proto-obj-y:.o=.pb-c.d))
 endif
+endif
 
-cleanup-y += $(obj)/*.c.d $(obj)/*.pb-c.c $(obj)/*.pb-c.h
+mrproper-y += $(obj)/*.pb-c.c $(obj)/*.pb-c.h
+cleanup-y += $(obj)/*.o $(obj)/*.d $(obj)/*.s $(obj)/*.i
 cleanup-y += $(obj)/google/protobuf/*.d
 cleanup-y += $(obj)/google/protobuf/*.h
 cleanup-y += $(obj)/google/protobuf/*.c

=== criu/pie/Makefile ===
--- 
+++ 
@@ -96,8 +96,10 @@
 $(BLOBS): $(obj)/$(PIELDS)
 all-y += $(BLOBS)
 
+# blobs and pields are in cleanup, rather than in mrproper because
+# we want them to be re-generated after `make clean && make`
+cleanup-y += $(BLOBS)
 cleanup-y += $(obj)/$(PIELDS)
 cleanup-y += $(obj)/*.bin
-cleanup-y += $(BLOBS)
 cleanup-y += $(obj)/*.built-in.bin.o
 cleanup-y += $(obj)/*.built-in.bin

=== scripts/build/Makefile ===
ARCHES ?= armv7hf aarch64 ppc64le # x86_64
all: $(ARCHES)

Dockerfile.%: Dockerfile.%.hdr Dockerfile.tmpl
	cat $^ > $@

qemu-user-static:
	./extract-deb-pkg qemu-user-static

binfmt_misc:
	./binfmt_misc
.PHONY: binfmt_misc

%: Dockerfile.% qemu-user-static binfmt_misc
	docker build  -t criu-$@ -f $< ../..

clean:
	rm -rf qemu-user-static
	for ARCH in $(ARCHES); do \
		FILE=/proc/sys/fs/binfmt_misc/$$ARCH; \
		test -f $$FILE && echo -1 > $$FILE; \
		rm -f Dockerfile.$$ARCH; \
	done

=== debian/changelog ===
criu (2.2-1) unstable; urgency=medium

  * Imported Upstream version 2.2
  * Drop build-Don-t-pass-wrap-on-every-linking-file-only-for.patch

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 20 May 2016 14:18:04 +0200

criu (2.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 12 May 2016 17:22:37 +0200

criu (2.1-1) experimental; urgency=medium

  * Imported Upstream version 2.1
  * Declare compliance with Debian policy 3.9.8
  * Don't pass --wrap on every linking file only for CRIU target only

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 05 May 2016 14:28:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: criu
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Salvatore Bonaccorso <carnil@debian.org>
+Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends:
  asciidoc,
  debhelper (>= 9.20151219),
@@ -15,7 +14,7 @@
  protobuf-compiler,
  python-all (>= 2.6.6-3~),
  xmlto
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Homepage: http://www.criu.org/
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/criu.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/criu.git

=== debian/rules ===
--- 
+++ 
@@ -14,10 +14,6 @@
 	# /usr/lib/systemd/system should not be installed
 	find $(TMP)/usr/lib -type d -empty -delete
 
-override_dh_auto_build:
-	# CRIU doesn't talk to the linker through gcc
-	LDFLAGS=-Bsymbolic-functions dh_auto_build
-
 override_dh_auto_test:
 	# disabled: doesn't work yet

## criu 2.5

=== debian/changelog ===
criu (2.5-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 19 Aug 2016 10:24:28 +0200

criu (2.5-1) experimental; urgency=medium

  * Imported Upstream version 2.5

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 16 Aug 2016 15:34:44 +0200

criu (2.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 22 Jul 2016 14:12:06 +0200

criu (2.4-1) experimental; urgency=low

  * Imported Upstream version 2.4
  * Add copyright information for new included file
  * Set LIBEXECDIR to /usr/lib during installation of files.
    Make sure that systemd-autofs-restart.sh helper is installed into
    /usr/lib/criu/scripts/.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 14 Jul 2016 07:24:53 +0200

criu (2.3-3) unstable; urgency=medium

  * build: nmk -- Filter out -Wl flags from linking builtin targets

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 30 Jun 2016 18:03:48 +0200

criu (2.3-2) unstable; urgency=medium

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 28 Jun 2016 15:51:45 +0200

criu (2.3-1) experimental; urgency=medium

  * Imported Upstream version 2.3
  * debian/copyright: Use HTTPS transport protocol for Format URL

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 17 Jun 2016 07:09:17 +0200
